package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.scene.SceneAccidentParam;
import api.common.pojo.po.scene.SceneAccidentPO;
import api.common.pojo.vo.scene.SceneAccidentVO;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.feign.FileDownService;
import com.css.simulation.resource.scene.service.SceneAccidentService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.BeanUtils;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

//交通事故场景
@RestController
@RequestMapping("/SceneAccident")
public class SceneAccidentController {

    @Resource
    SceneAccidentService sceneAccidentService;

//查询列表
    @PostMapping("/querySceneAccidentList")
    @ResponseBody
    public ResponseBodyVO<List<SceneAccidentVO>> querySceneAccidentList(@RequestBody SceneAccidentParam parms) {
        PageUtil.setPageInfo(parms);
        List<SceneAccidentPO> list=sceneAccidentService.querySceneAccidentList(parms);
        PageInfo<SceneAccidentPO> objectPageInfo = new PageInfo<>(list);
        List<SceneAccidentVO> list1=new ArrayList<>();
        for (SceneAccidentPO po: list) {
            SceneAccidentVO vo=new SceneAccidentVO();
            BeanUtils.copyProperties(po,vo);
            list1.add(vo);
        }
        PageInfo pageInfo=new PageInfo<>(list1);
        pageInfo.setTotal(objectPageInfo.getTotal());
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,pageInfo);
    }


    //新增交通事故
    @PostMapping("/saveSceneAccident")
    @ResponseBody
    public ResponseBodyVO<String> saveSceneAccident(@RequestBody SceneAccidentParam parms) {
        sceneAccidentService.importJtSg(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //新增交通事故
    @PostMapping("/saveSceneAccidentCS")
    @ResponseBody
    public ResponseBodyVO<String> saveSceneAccidentCS(@RequestBody SceneAccidentParam parms) {
        sceneAccidentService.importJtSgCS(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }
    @Resource
    private FileDownService fileDownService;

    @PostMapping(value = "/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<String> upload(@RequestPart("file") MultipartFile file,
                                         @RequestParam("objectName") String objectName) {

        objectName=objectName+"/"+file.getOriginalFilename();
        System.out.println("上传文件名称--------"+objectName);
        return fileDownService.upload(file,objectName);
    }


}