package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.scene.SceneNaturalParam;
import api.common.pojo.po.scene.SceneNaturalPO;
import api.common.pojo.vo.scene.SceneNaturalVO;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.feign.FileDownService;
import com.css.simulation.resource.scene.service.SceneNaturalService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.BeanUtils;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

//自然场景
@RestController
@RequestMapping("/SceneNatural")
public class SceneNaturalController {

    @Resource
    SceneNaturalService sceneNaturalService;

//查询列表
    @PostMapping("/querySceneNaturalList")
    @ResponseBody
    public ResponseBodyVO<List<SceneNaturalVO>> querySceneNaturalList(@RequestBody SceneNaturalParam parms) {
        PageUtil.setPageInfo(parms);
        List<SceneNaturalPO> list=sceneNaturalService.querySceneNaturalList(parms);
        PageInfo<SceneNaturalPO> objectPageInfo = new PageInfo<>(list);
        List<SceneNaturalVO> list1=new ArrayList<>();
        for (SceneNaturalPO po: list) {
            SceneNaturalVO vo=new SceneNaturalVO();
            BeanUtils.copyProperties(po,vo);
            list1.add(vo);
        }
        PageInfo pageInfo=new PageInfo<>(list1);
        pageInfo.setTotal(objectPageInfo.getTotal());
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,pageInfo);
    }


    //新增标准法规
    @PostMapping("/saveSceneAccident")
    @ResponseBody
    public ResponseBodyVO<String> saveSceneAccident(@RequestBody SceneNaturalParam parms) {
        sceneNaturalService.importZrjsSceneCicv(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    @Resource
    private FileDownService fileDownService;

    @PostMapping(value = "/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<String> upload(@RequestPart("file") MultipartFile file,
                                         @RequestParam("objectName") String objectName) {
        System.out.println("上传文件名称--------"+file.getOriginalFilename());
        return fileDownService.upload(file,file.getOriginalFilename());
    }


}