package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.scene.ScenePackageParam;
import api.common.pojo.po.scene.ScenePackagePO;
import api.common.pojo.vo.scene.ScenePackageSublistVO;
import api.common.pojo.vo.scene.ScenePackageVO;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.scene.service.ScenePackageService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.BeanUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

//测试包
@RestController
@RequestMapping("/ScenePackage")
public class ScenePackageController {

    @Resource
    ScenePackageService scenePackageService;

//查询主表列表
    @PostMapping("/queryScenePackageList")
    @ResponseBody
    public ResponseBodyVO<List<ScenePackageVO>> queryScenePackageList(@RequestBody ScenePackageParam parms) {
        PageUtil.setPageInfo(parms);
        List<ScenePackagePO> list=scenePackageService.queryScenePackageList(parms);
        PageInfo<ScenePackagePO> objectPageInfo = new PageInfo<>(list);
        List<ScenePackageVO> list1=new ArrayList<>();
        for (ScenePackagePO po: list) {
            ScenePackageVO vo=new ScenePackageVO();
            BeanUtils.copyProperties(po,vo);
            list1.add(vo);
        }
        PageInfo pageInfo=new PageInfo<>(list1);
        pageInfo.setTotal(objectPageInfo.getTotal());
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,pageInfo);
    }

    //查询测试包详情
    @PostMapping("/queryScenePackage")
    @ResponseBody
    public ResponseBodyVO<ScenePackageVO> queryScenePackage(@RequestBody ScenePackageParam parms) {
       ScenePackagePO po=scenePackageService.queryScenePackage(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,po);
    }


    //新增打分规则
    @PostMapping("/saveScenePackage")
    @ResponseBody
    public ResponseBodyVO<String> saveScoringRules(@RequestBody ScenePackagePO parms) {
        scenePackageService.saveScenePackage(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //修改打分规则
    @PostMapping("/updateScenePackage")
    @ResponseBody
    public ResponseBodyVO<String> updateScenePackage(@RequestBody ScenePackagePO params)  {
        scenePackageService.updateScenePackage(params);
        return new ResponseBodyVO<>(ResponseBodyVO.Response.SUCCESS);
    }

    //查询一个测试包列表
    @PostMapping("/queryScenePackageSublistList")
    @ResponseBody
    public ResponseBodyVO<ScenePackageSublistVO> queryScenePackageSublistList(@RequestBody ScenePackageParam parms) {
        ScenePackageSublistVO po=  scenePackageService.queryScenePackageSublistList(parms);

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,po);
    }


}