package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.MinioParameter;
import api.common.pojo.param.scene.ScoringRulesParam;
import api.common.pojo.po.scene.ScoringRulesPO;
import api.common.pojo.vo.scene.ScoringRulesVO;
import api.common.util.FileUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.feign.FileDownService;
import com.css.simulation.resource.scene.service.ScoringRulesService;
import com.github.pagehelper.PageInfo;
import feign.Response;
import org.springframework.beans.BeanUtils;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

//打分规则
@RestController
@RequestMapping("/ScoringRules")
public class ScoringRulesController {

    @Resource
    ScoringRulesService scoringRulesService;

//查询列表
    @PostMapping("/queryScoringRulesList")
    @ResponseBody
    public ResponseBodyVO<List<ScoringRulesVO>> queryScoringRulesList(@RequestBody ScoringRulesParam parms) {
        PageUtil.setPageInfo(parms);
        List<ScoringRulesPO> list=scoringRulesService.queryScoringRulesList(parms);
        PageInfo<ScoringRulesPO> scoringRulesPOPageInfo = new PageInfo<>(list);
        List<ScoringRulesVO> list1=new ArrayList<>();
        for (ScoringRulesPO po: list) {
            ScoringRulesVO vo=new ScoringRulesVO();
            BeanUtils.copyProperties(po,vo);
            list1.add(vo);
        }
        PageInfo pageInfo = new PageInfo(list1);
        pageInfo.setTotal(scoringRulesPOPageInfo.getTotal());

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,pageInfo);
    }

     //查询详情
    @PostMapping("/queryScoringRules")
    @ResponseBody
    public ResponseBodyVO<List<ScoringRulesPO>> queryScoringRules(@RequestBody ScoringRulesParam parms)  {
        ScoringRulesPO po=scoringRulesService.queryScoringRules(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,po);
    }

    //新增打分规则
    @PostMapping("/saveScoringRules")
    @ResponseBody
    public ResponseBodyVO<String> saveScoringRules(@RequestBody ScoringRulesPO parms) {
        scoringRulesService.saveScoringRules(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    //修改打分规则
    @PostMapping("/updateScoringRules")
    @ResponseBody
    public ResponseBodyVO<String> updateScoringRules(@RequestBody ScoringRulesPO params)  {
       scoringRulesService.updateScoringRules(params);
        return new ResponseBodyVO<>(ResponseBodyVO.Response.SUCCESS);
    }


    @Resource
    private FileDownService fileDownService;

    @PostMapping(value = "/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<String> upload(@RequestPart("file") MultipartFile file,
                                         @RequestParam("objectName") String objectName) {
        System.out.println("上传文件名称--------"+file.getOriginalFilename());
        return fileDownService.upload(file,file.getOriginalFilename());
    }

@GetMapping(value = "/download")
    public void download(
            HttpServletResponse response
    ) throws IOException {
    MinioParameter parms=new MinioParameter();
    parms.setObjectName("new4.txt");
        Response download = fileDownService.download(parms);
        Response.Body body = download.body();
        InputStream inputStream = body.asInputStream();
        FileUtil.downloadForHttp(parms.getObjectName(), inputStream, response, 1024);
    }

}